from bolsonaro.utils import save_obj_to_json, load_obj_from_json

import os


class ModelParameters(object):

    def __init__(self, forest_size, extracted_forest_size, normalize_D, use_dev_subset, seed=None):
        self._forest_size = forest_size
        self._extracted_forest_size = extracted_forest_size
        self._normalize_D = normalize_D
        self._use_dev_subset = use_dev_subset
        self._seed = seed

    @property
    def forest_size(self):
        return self._forest_size

    @property
    def extracted_forest_size(self):
        return self._extracted_forest_size

    @property
    def normalize_D(self):
        return self._normalize_D

    @property
    def use_dev_subset(self):
        return self._use_dev_subset

    @property
    def seed(self):
        return self._seed

    def save(self, directory_path, experiment_id):
        save_obj_to_json(directory_path + os.sep + 'model_parameters_{}.json'.format(experiment_id),
            self.__dict__)

    @staticmethod
    def load(directory_path, experiment_id):
        return load_obj_from_json(directory_path + os.sep + 'model_parameters_{}.json'.format(experiment_id),
            ModelParameters)
