from bolsonaro.utils import save_obj_to_pickle, load_obj_from_pickle

import os
import datetime


class ModelRawResults(object):

    def __init__(self, forest, weights, training_time,
        datetime, train_score, dev_score, test_score,
        score_metric, train_score_regressor, dev_score_regressor,
        test_score_regressor):

        self._forest = forest
        self._weights = weights
        self._training_time = training_time
        self._datetime = datetime
        self._train_score = train_score
        self._dev_score = dev_score
        self._test_score = test_score
        self._score_metric = score_metric
        self._train_score_regressor = train_score_regressor
        self._dev_score_regressor = dev_score_regressor
        self._test_score_regressor = test_score_regressor
    
    @property
    def forest(self):
        return self._forest

    @property
    def weights(self):
        return self._weights

    @property
    def training_time(self):
        return self._training_time

    @property
    def datetime(self):
        return self._datetime

    @property
    def train_score(self):
        return self._train_score

    @property
    def dev_score(self):
        return self._dev_score

    @property
    def test_score(self):
        return self._test_score

    @property
    def score_metric(self):
        return self._score_metric

    @property
    def train_score_regressor(self):
        return self._train_score_regressor

    @property
    def dev_score_regressor(self):
        return self._dev_score_regressor

    @property
    def test_score_regressor(self):
        return self._test_score_regressor

    def save(self, models_dir):
        save_obj_to_pickle(models_dir + os.sep + 'model_raw_results.pickle',
            self.__dict__)

    @staticmethod
    def load(models_dir):        
        return load_obj_from_pickle(models_dir + os.sep + 'model_raw_results.pickle',
            ModelRawResults)
